git-am.sh 19.5 KB
Newer Older
1 2
#!/bin/sh
#
3
# Copyright (c) 2005, 2006 Junio C Hamano
4

5
SUBDIRECTORY_OK=Yes
6 7
OPTIONS_KEEPDASHDASH=
OPTIONS_SPEC="\
8
git am [options] [(<mbox>|<Maildir>)...]
9
git am [options] (--resolved | --skip | --abort)
10
--
11
i,interactive   run interactively
J
Jay Soffian 已提交
12
b,binary*       (historical option -- no-op)
13
3,3way          allow fall back on 3way merging if needed
S
Stephen Boyd 已提交
14
q,quiet         be quiet
15 16
s,signoff       add a Signed-off-by line to the commit message
u,utf8          recode into utf8 (default)
17
k,keep          pass -k flag to git-mailinfo
18
keep-cr         pass --keep-cr flag to git-mailsplit for mbox format
19
no-keep-cr      do not pass --keep-cr flag to git-mailsplit independent of am.keepcr
20
c,scissors      strip everything before a scissors line
21
whitespace=     pass it through git-apply
22 23
ignore-space-change pass it through git-apply
ignore-whitespace pass it through git-apply
24
directory=      pass it through git-apply
25 26
C=              pass it through git-apply
p=              pass it through git-apply
27
patch-format=   format the patch(es) are in
28
reject          pass it through git-apply
29
resolvemsg=     override error message when patch failure occurs
J
Jeff King 已提交
30 31
continue        continue applying patches after resolving a conflict
r,resolved      synonyms for --continue
J
Junio C Hamano 已提交
32
skip            skip the current patch
N
Nanako Shiraishi 已提交
33
abort           restore the original branch and abort the patching operation.
34
committer-date-is-author-date    lie about committer date
35
ignore-date     use current timestamp for author date
36
rerere-autoupdate update the index with reused conflict resolution if possible
J
Jay Soffian 已提交
37
rebasing*       (internal use for git-rebase)"
38

39
. git-sh-setup
40
prefix=$(git rev-parse --show-prefix)
41
set_reflog_action am
42
require_work_tree
43
cd_to_toplevel
44

45 46
git var GIT_COMMITTER_IDENT >/dev/null ||
	die "You need to set your committer info first"
47

48 49 50 51 52 53 54
if git rev-parse --verify -q HEAD >/dev/null
then
	HAS_HEAD=yes
else
	HAS_HEAD=
fi

55 56 57 58 59 60 61 62 63 64
cmdline="git am"
if test '' != "$interactive"
then
	cmdline="$cmdline -i"
fi
if test '' != "$threeway"
then
	cmdline="$cmdline -3"
fi

65
sq () {
66
	git rev-parse --sq-quote "$@"
67 68
}

69 70
stop_here () {
    echo "$1" >"$dotest/next"
71
    git rev-parse --verify -q HEAD >"$dotest/abort-safety"
72 73 74
    exit 1
}

75 76 77 78 79 80 81 82 83 84 85 86 87 88 89 90 91 92 93 94 95
safe_to_abort () {
	if test -f "$dotest/dirtyindex"
	then
		return 1
	fi

	if ! test -s "$dotest/abort-safety"
	then
		return 0
	fi

	abort_safety=$(cat "$dotest/abort-safety")
	if test "z$(git rev-parse --verify -q HEAD)" = "z$abort_safety"
	then
		return 0
	fi
	echo >&2 "You seem to have moved HEAD since the last 'am' failure."
	echo >&2 "Not rewinding to ORIG_HEAD"
	return 1
}

96
stop_here_user_resolve () {
97
    if [ -n "$resolvemsg" ]; then
J
Jeff King 已提交
98
	    printf '%s\n' "$resolvemsg"
99 100
	    stop_here $1
    fi
101 102
    echo "When you have resolved this problem run \"$cmdline --resolved\"."
    echo "If you would prefer to skip this patch, instead run \"$cmdline --skip\"."
N
Nanako Shiraishi 已提交
103
    echo "To restore the original branch and stop patching run \"$cmdline --abort\"."
104 105 106 107

    stop_here $1
}

108 109 110 111 112 113 114
go_next () {
	rm -f "$dotest/$msgnum" "$dotest/msg" "$dotest/msg-clean" \
		"$dotest/patch" "$dotest/info"
	echo "$next" >"$dotest/next"
	this=$next
}

115 116 117 118 119 120
cannot_fallback () {
	echo "$1"
	echo "Cannot fall back to three-way merge."
	exit 1
}

121 122 123 124 125 126 127
fall_back_3way () {
    O_OBJECT=`cd "$GIT_OBJECT_DIRECTORY" && pwd`

    rm -fr "$dotest"/patch-merge-*
    mkdir "$dotest/patch-merge-tmp-dir"

    # First see if the patch records the index info that we can use.
128 129
    git apply --build-fake-ancestor "$dotest/patch-merge-tmp-index" \
	"$dotest/patch" &&
130
    GIT_INDEX_FILE="$dotest/patch-merge-tmp-index" \
131
    git write-tree >"$dotest/patch-merge-base+" ||
132
    cannot_fallback "Repository lacks necessary blobs to fall back on 3-way merge."
133

S
Stephen Boyd 已提交
134
    say Using index info to reconstruct a base tree...
135
    if GIT_INDEX_FILE="$dotest/patch-merge-tmp-index" \
S
Stephan Beyer 已提交
136
	git apply --cached <"$dotest/patch"
137 138 139
    then
	mv "$dotest/patch-merge-base+" "$dotest/patch-merge-base"
	mv "$dotest/patch-merge-tmp-index" "$dotest/patch-merge-index"
140 141 142
    else
        cannot_fallback "Did you hand edit your patch?
It does not apply to blobs recorded in its index."
143 144 145
    fi

    test -f "$dotest/patch-merge-index" &&
146
    his_tree=$(GIT_INDEX_FILE="$dotest/patch-merge-index" git write-tree) &&
147 148 149
    orig_tree=$(cat "$dotest/patch-merge-base") &&
    rm -fr "$dotest"/patch-merge-* || exit 1

S
Stephen Boyd 已提交
150
    say Falling back to patching base and 3-way merge...
151 152 153 154

    # This is not so wrong.  Depending on which base we picked,
    # orig_tree may be wildly different from ours, but his_tree
    # has the same set of wildly different changes in parts the
155
    # patch did not touch, so recursive ends up canceling them,
156 157
    # saying that we reverted all those changes.

158
    eval GITHEAD_$his_tree='"$FIRSTLINE"'
159
    export GITHEAD_$his_tree
S
Stephen Boyd 已提交
160 161
    if test -n "$GIT_QUIET"
    then
162
	    GIT_MERGE_VERBOSITY=0 && export GIT_MERGE_VERBOSITY
S
Stephen Boyd 已提交
163
    fi
164
    git-merge-recursive $orig_tree -- HEAD $his_tree || {
165
	    git rerere $allow_rerere_autoupdate
166 167 168
	    echo Failed to merge in the changes.
	    exit 1
    }
169
    unset GITHEAD_$his_tree
170 171
}

172 173 174 175 176 177
clean_abort () {
	test $# = 0 || echo >&2 "$@"
	rm -fr "$dotest"
	exit 1
}

178 179 180 181 182 183 184 185
patch_format=

check_patch_format () {
	# early return if patch_format was set from the command line
	if test -n "$patch_format"
	then
		return 0
	fi
186 187 188 189 190 191 192 193 194 195 196 197 198 199 200 201 202 203 204 205 206 207 208 209 210 211 212 213 214 215 216 217 218 219 220 221 222 223

	# we default to mbox format if input is from stdin and for
	# directories
	if test $# = 0 || test "x$1" = "x-" || test -d "$1"
	then
		patch_format=mbox
		return 0
	fi

	# otherwise, check the first few lines of the first patch to try
	# to detect its format
	{
		read l1
		read l2
		read l3
		case "$l1" in
		"From "* | "From: "*)
			patch_format=mbox
			;;
		'# This series applies on GIT commit'*)
			patch_format=stgit-series
			;;
		"# HG changeset patch")
			patch_format=hg
			;;
		*)
			# if the second line is empty and the third is
			# a From, Author or Date entry, this is very
			# likely an StGIT patch
			case "$l2,$l3" in
			,"From: "* | ,"Author: "* | ,"Date: "*)
				patch_format=stgit
				;;
			*)
				;;
			esac
			;;
		esac
224 225 226 227 228 229 230 231 232 233
		if test -z "$patch_format" &&
			test -n "$l1" &&
			test -n "$l2" &&
			test -n "$l3"
		then
			# This begins with three non-empty lines.  Is this a
			# piece of e-mail a-la RFC2822?  Grab all the headers,
			# discarding the indented remainder of folded lines,
			# and see if it looks like that they all begin with the
			# header field names...
234 235
			tr -d '\015' <"$1" |
			sed -n -e '/^$/q' -e '/^[ 	]/d' -e p |
236
			sane_egrep -v '^[!-9;-~]+:' >/dev/null ||
237 238
			patch_format=mbox
		fi
239
	} < "$1" || clean_abort
240 241 242 243 244
}

split_patches () {
	case "$patch_format" in
	mbox)
245
		if test -n "$rebasing" || test t = "$keepcr"
246 247 248 249 250
		then
		    keep_cr=--keep-cr
		else
		    keep_cr=
		fi
251
		git mailsplit -d"$prec" -o"$dotest" -b $keep_cr -- "$@" > "$dotest/last" ||
252
		clean_abort
253
		;;
254 255 256
	stgit-series)
		if test $# -ne 1
		then
257
			clean_abort "Only one StGIT patch series can be applied at once"
258 259 260 261 262 263 264 265 266 267 268 269 270 271
		fi
		series_dir=`dirname "$1"`
		series_file="$1"
		shift
		{
			set x
			while read filename
			do
				set "$@" "$series_dir/$filename"
			done
			# remove the safety x
			shift
			# remove the arg coming from the first-line comment
			shift
272
		} < "$series_file" || clean_abort
273 274 275 276 277 278 279 280 281 282 283 284 285 286 287 288 289 290 291 292 293 294 295 296 297 298 299 300
		# set the patch format appropriately
		patch_format=stgit
		# now handle the actual StGIT patches
		split_patches "$@"
		;;
	stgit)
		this=0
		for stgit in "$@"
		do
			this=`expr "$this" + 1`
			msgnum=`printf "%0${prec}d" $this`
			# Perl version of StGIT parse_patch. The first nonemptyline
			# not starting with Author, From or Date is the
			# subject, and the body starts with the next nonempty
			# line not starting with Author, From or Date
			perl -ne 'BEGIN { $subject = 0 }
				if ($subject > 1) { print ; }
				elsif (/^\s+$/) { next ; }
				elsif (/^Author:/) { print s/Author/From/ ; }
				elsif (/^(From|Date)/) { print ; }
				elsif ($subject) {
					$subject = 2 ;
					print "\n" ;
					print ;
				} else {
					print "Subject: ", $_ ;
					$subject = 1;
				}
301
			' < "$stgit" > "$dotest/$msgnum" || clean_abort
302 303 304 305 306
		done
		echo "$this" > "$dotest/last"
		this=
		msgnum=
		;;
307
	*)
308 309 310 311 312
		if test -n "$parse_patch" ; then
			clean_abort "Patch format $patch_format is not supported."
		else
			clean_abort "Patch format detection failed."
		fi
313 314 315 316
		;;
	esac
}

317
prec=4
318
dotest="$GIT_DIR/rebase-apply"
319
sign= utf8=t keep= keepcr= skip= interactive= resolved= rebasing= abort=
320
resolvemsg= resume= scissors= no_inbody_headers=
M
Michael S. Tsirkin 已提交
321
git_apply_opt=
322
committer_date_is_author_date=
323
ignore_date=
324
allow_rerere_autoupdate=
325

326 327 328 329 330
if test "$(git config --bool --get am.keepcr)" = true
then
    keepcr=t
fi

331
while test $# != 0
332 333
do
	case "$1" in
334 335 336
	-i|--interactive)
		interactive=t ;;
	-b|--binary)
S
Stephan Beyer 已提交
337
		: ;;
338 339
	-3|--3way)
		threeway=t ;;
340
	-s|--signoff)
341 342 343 344 345 346 347
		sign=t ;;
	-u|--utf8)
		utf8=t ;; # this is now default
	--no-utf8)
		utf8= ;;
	-k|--keep)
		keep=t ;;
348 349 350 351
	-c|--scissors)
		scissors=t ;;
	--no-scissors)
		scissors=f ;;
J
Jeff King 已提交
352
	-r|--resolved|--continue)
353 354 355
		resolved=t ;;
	--skip)
		skip=t ;;
N
Nanako Shiraishi 已提交
356 357
	--abort)
		abort=t ;;
J
Junio C Hamano 已提交
358
	--rebasing)
359
		rebasing=t threeway=t keep=t scissors=f no_inbody_headers=t ;;
360
	-d|--dotest)
361 362
		die "-d option is no longer supported.  Do not use."
		;;
363 364
	--resolvemsg)
		shift; resolvemsg=$1 ;;
365 366
	--whitespace|--directory)
		git_apply_opt="$git_apply_opt $(sq "$1=$2")"; shift ;;
367
	-C|-p)
368
		git_apply_opt="$git_apply_opt $(sq "$1$2")"; shift ;;
369 370
	--patch-format)
		shift ; patch_format="$1" ;;
371
	--reject|--ignore-whitespace|--ignore-space-change)
372
		git_apply_opt="$git_apply_opt $1" ;;
373 374
	--committer-date-is-author-date)
		committer_date_is_author_date=t ;;
375 376
	--ignore-date)
		ignore_date=t ;;
377 378
	--rerere-autoupdate|--no-rerere-autoupdate)
		allow_rerere_autoupdate="$1" ;;
S
Stephen Boyd 已提交
379 380
	-q|--quiet)
		GIT_QUIET=t ;;
381 382
	--keep-cr)
		keepcr=t ;;
383 384
	--no-keep-cr)
		keepcr=f ;;
385
	--)
386
		shift; break ;;
387
	*)
388
		usage ;;
389
	esac
390
	shift
391 392
done

J
Junio C Hamano 已提交
393 394
# If the dotest directory exists, but we have finished applying all the
# patches in them, clear it out.
395 396 397 398 399 400 401 402 403 404 405
if test -d "$dotest" &&
   last=$(cat "$dotest/last") &&
   next=$(cat "$dotest/next") &&
   test $# != 0 &&
   test "$next" -gt "$last"
then
   rm -fr "$dotest"
fi

if test -d "$dotest"
then
N
Nanako Shiraishi 已提交
406
	case "$#,$skip$resolved$abort" in
J
Junio C Hamano 已提交
407 408 409 410 411 412 413
	0,*t*)
		# Explicit resume command and we do not have file, so
		# we are happy.
		: ;;
	0,)
		# No file input but without resume parameters; catch
		# user error to feed us a patch from standard input
414
		# when there is already $dotest.  This is somewhat
J
Junio C Hamano 已提交
415 416 417
		# unreliable -- stdin could be /dev/null for example
		# and the caller did not intend to feed us a patch but
		# wanted to continue unattended.
J
Jay Soffian 已提交
418
		test -t 0
J
Junio C Hamano 已提交
419 420 421 422 423
		;;
	*)
		false
		;;
	esac ||
424
	die "previous rebase directory $dotest still exists but mbox given."
425
	resume=yes
N
Nanako Shiraishi 已提交
426

427
	case "$skip,$abort" in
428 429 430
	t,t)
		die "Please make up your mind. --skip or --abort?"
		;;
431 432 433 434 435 436 437 438
	t,)
		git rerere clear
		git read-tree --reset -u HEAD HEAD
		orig_head=$(cat "$GIT_DIR/ORIG_HEAD")
		git reset HEAD
		git update-ref ORIG_HEAD $orig_head
		;;
	,t)
439 440 441 442
		if test -f "$dotest/rebasing"
		then
			exec git rebase --abort
		fi
N
Nanako Shiraishi 已提交
443
		git rerere clear
444 445
		if safe_to_abort
		then
446 447
			git read-tree --reset -u HEAD ORIG_HEAD
			git reset ORIG_HEAD
448
		fi
N
Nanako Shiraishi 已提交
449 450 451
		rm -fr "$dotest"
		exit ;;
	esac
452
	rm -f "$dotest/dirtyindex"
453
else
N
Nanako Shiraishi 已提交
454 455
	# Make sure we are not given --skip, --resolved, nor --abort
	test "$skip$resolved$abort" = "" ||
456
		die "Resolve operation not in progress, we are not resuming."
457 458 459 460

	# Start afresh.
	mkdir -p "$dotest" || exit

461 462 463 464 465 466 467 468 469
	if test -n "$prefix" && test $# != 0
	then
		first=t
		for arg
		do
			test -n "$first" && {
				set x
				first=
			}
470 471 472 473 474 475
			if is_absolute_path "$arg"
			then
				set "$@" "$arg"
			else
				set "$@" "$prefix$arg"
			fi
476 477 478
		done
		shift
	fi
479 480 481 482

	check_patch_format "$@"

	split_patches "$@"
483

484 485
	# -i can and must be given when resuming; everything
	# else is kept
486
	echo " $git_apply_opt" >"$dotest/apply-opt"
487
	echo "$threeway" >"$dotest/threeway"
488 489 490
	echo "$sign" >"$dotest/sign"
	echo "$utf8" >"$dotest/utf8"
	echo "$keep" >"$dotest/keep"
491
	echo "$keepcr" >"$dotest/keepcr"
492
	echo "$scissors" >"$dotest/scissors"
493
	echo "$no_inbody_headers" >"$dotest/no_inbody_headers"
S
Stephen Boyd 已提交
494
	echo "$GIT_QUIET" >"$dotest/quiet"
495
	echo 1 >"$dotest/next"
J
Junio C Hamano 已提交
496 497 498 499 500
	if test -n "$rebasing"
	then
		: >"$dotest/rebasing"
	else
		: >"$dotest/applying"
501 502 503 504 505 506
		if test -n "$HAS_HEAD"
		then
			git update-ref ORIG_HEAD HEAD
		else
			git update-ref -d ORIG_HEAD >/dev/null 2>&1
		fi
J
Junio C Hamano 已提交
507
	fi
508 509
fi

J
Junio C Hamano 已提交
510 511
case "$resolved" in
'')
512 513 514 515 516 517
	case "$HAS_HEAD" in
	'')
		files=$(git ls-files) ;;
	?*)
		files=$(git diff-index --cached --name-only HEAD --) ;;
	esac || exit
518 519
	if test "$files"
	then
520
		test -n "$HAS_HEAD" && : >"$dotest/dirtyindex"
521 522
		die "Dirty index: cannot apply patches (dirty: $files)"
	fi
J
Junio C Hamano 已提交
523 524
esac

525 526 527
if test "$(cat "$dotest/utf8")" = t
then
	utf8=-u
528 529
else
	utf8=-n
530 531 532 533 534
fi
if test "$(cat "$dotest/keep")" = t
then
	keep=-k
fi
535 536 537 538 539 540
case "$(cat "$dotest/keepcr")" in
t)
	keepcr=--keep-cr ;;
f)
	keepcr=--no-keep-cr ;;
esac
541 542 543 544 545 546
case "$(cat "$dotest/scissors")" in
t)
	scissors=--scissors ;;
f)
	scissors=--no-scissors ;;
esac
547 548 549 550 551 552
if test "$(cat "$dotest/no_inbody_headers")" = t
then
	no_inbody_headers=--no-inbody-headers
else
	no_inbody_headers=
fi
S
Stephen Boyd 已提交
553 554 555 556
if test "$(cat "$dotest/quiet")" = t
then
	GIT_QUIET=t
fi
557 558 559 560
if test "$(cat "$dotest/threeway")" = t
then
	threeway=t
fi
561
git_apply_opt=$(cat "$dotest/apply-opt")
562 563
if test "$(cat "$dotest/sign")" = t
then
564
	SIGNOFF=`git var GIT_COMMITTER_IDENT | sed -e '
565 566 567 568 569 570 571 572 573 574 575 576
			s/>.*/>/
			s/^/Signed-off-by: /'
		`
else
	SIGNOFF=
fi

last=`cat "$dotest/last"`
this=`cat "$dotest/next"`
if test "$skip" = t
then
	this=`expr "$this" + 1`
J
Jan Harkes 已提交
577
	resume=
578 579 580 581 582 583 584
fi

while test "$this" -le "$last"
do
	msgnum=`printf "%0${prec}d" $this`
	next=`expr "$this" + 1`
	test -f "$dotest/$msgnum" || {
J
Jan Harkes 已提交
585
		resume=
586 587 588
		go_next
		continue
	}
J
Junio C Hamano 已提交
589 590 591 592 593 594 595 596 597

	# If we are not resuming, parse and extract the patch information
	# into separate files:
	#  - info records the authorship and title
	#  - msg is the rest of commit log message
	#  - patch is the patch body.
	#
	# When we are resuming, these files are either already prepared
	# by the user, or the user can tell us to do so by --resolved flag.
598 599
	case "$resume" in
	'')
600
		git mailinfo $keep $no_inbody_headers $scissors $utf8 "$dotest/msg" "$dotest/patch" \
601 602
			<"$dotest/$msgnum" >"$dotest/info" ||
			stop_here $this
603 604

		# skip pine's internal folder data
605
		sane_grep '^Author: Mail System Internal Data$' \
606 607 608
			<"$dotest"/info >/dev/null &&
			go_next && continue

609
		test -s "$dotest/patch" || {
610
			echo "Patch is empty.  Was it split wrong?"
611 612
			echo "If you would prefer to skip this patch, instead run \"$cmdline --skip\"."
			echo "To restore the original branch and stop patching run \"$cmdline --abort\"."
613 614
			stop_here $this
		}
615
		rm -f "$dotest/original-commit" "$dotest/author-script"
616 617 618 619 620 621 622
		if test -f "$dotest/rebasing" &&
			commit=$(sed -e 's/^From \([0-9a-f]*\) .*/\1/' \
				-e q "$dotest/$msgnum") &&
			test "$(git cat-file -t "$commit")" = commit
		then
			git cat-file commit "$commit" |
			sed -e '1,/^$/d' >"$dotest/msg-clean"
T
Thomas Rast 已提交
623
			echo "$commit" > "$dotest/original-commit"
624
			get_author_ident_from_commit "$commit" > "$dotest/author-script"
625
		else
J
Junio C Hamano 已提交
626 627 628 629 630 631
			{
				sed -n '/^Subject/ s/Subject: //p' "$dotest/info"
				echo
				cat "$dotest/msg"
			} |
			git stripspace > "$dotest/msg-clean"
632
		fi
633 634
		;;
	esac
635

636 637 638 639 640 641 642 643
	if test -f "$dotest/author-script"
	then
		eval $(cat "$dotest/author-script")
	else
		GIT_AUTHOR_NAME="$(sed -n '/^Author/ s/Author: //p' "$dotest/info")"
		GIT_AUTHOR_EMAIL="$(sed -n '/^Email/ s/Email: //p' "$dotest/info")"
		GIT_AUTHOR_DATE="$(sed -n '/^Date/ s/Date: //p' "$dotest/info")"
	fi
644

645
	if test -z "$GIT_AUTHOR_EMAIL"
646
	then
647
		echo "Patch does not have a valid e-mail address."
648 649 650
		stop_here $this
	fi

J
Junio C Hamano 已提交
651
	export GIT_AUTHOR_NAME GIT_AUTHOR_EMAIL GIT_AUTHOR_DATE
652

653 654 655 656
	case "$resume" in
	'')
	    if test '' != "$SIGNOFF"
	    then
657
		LAST_SIGNED_OFF_BY=`
658 659
		    sed -ne '/^Signed-off-by: /p' \
		    "$dotest/msg-clean" |
660
		    sed -ne '$p'
661
		`
662 663
		ADD_SIGNOFF=`
		    test "$LAST_SIGNED_OFF_BY" = "$SIGNOFF" || {
664 665
		    test '' = "$LAST_SIGNED_OFF_BY" && echo
		    echo "$SIGNOFF"
666 667
		}`
	    else
668
		ADD_SIGNOFF=
669 670
	    fi
	    {
671 672 673 674 675 676 677 678
		if test -s "$dotest/msg-clean"
		then
			cat "$dotest/msg-clean"
		fi
		if test '' != "$ADD_SIGNOFF"
		then
			echo "$ADD_SIGNOFF"
		fi
679 680
	    } >"$dotest/final-commit"
	    ;;
J
Junio C Hamano 已提交
681
	*)
682
		case "$resolved$interactive" in
J
Junio C Hamano 已提交
683 684
		tt)
			# This is used only for interactive view option.
685
			git diff-index -p --cached HEAD -- >"$dotest/patch"
J
Junio C Hamano 已提交
686 687
			;;
		esac
688
	esac
689

690
	resume=
691 692
	if test "$interactive" = t
	then
693 694
	    test -t 0 ||
	    die "cannot be interactive without stdin connected to a terminal."
695 696 697 698 699 700 701
	    action=again
	    while test "$action" = again
	    do
		echo "Commit Body is:"
		echo "--------------------------"
		cat "$dotest/final-commit"
		echo "--------------------------"
J
Jason Riedy 已提交
702
		printf "Apply? [y]es/[n]o/[e]dit/[v]iew patch/[a]ccept all "
703 704
		read reply
		case "$reply" in
705 706 707
		[yY]*) action=yes ;;
		[aA]*) action=yes interactive= ;;
		[nN]*) action=skip ;;
708
		[eE]*) git_editor "$dotest/final-commit"
709
		       action=again ;;
710
		[vV]*) action=again
J
Jonathan Nieder 已提交
711
		       git_pager "$dotest/patch" ;;
712
		*)     action=again ;;
713 714 715 716 717
		esac
	    done
	else
	    action=yes
	fi
718 719 720 721 722 723 724

	if test -f "$dotest/final-commit"
	then
		FIRSTLINE=$(sed 1q "$dotest/final-commit")
	else
		FIRSTLINE=""
	fi
725 726 727 728 729 730 731 732 733 734 735 736 737

	if test $action = skip
	then
		go_next
		continue
	fi

	if test -x "$GIT_DIR"/hooks/applypatch-msg
	then
		"$GIT_DIR"/hooks/applypatch-msg "$dotest/final-commit" ||
		stop_here $this
	fi

S
Stephen Boyd 已提交
738
	say "Applying: $FIRSTLINE"
739

J
Junio C Hamano 已提交
740 741
	case "$resolved" in
	'')
742 743 744 745 746 747 748 749
		# When we are allowed to fall back to 3-way later, don't give
		# false errors during the initial attempt.
		squelch=
		if test "$threeway" = t
		then
			squelch='>/dev/null 2>&1 '
		fi
		eval "git apply $squelch$git_apply_opt"' --index "$dotest/patch"'
J
Junio C Hamano 已提交
750 751 752 753 754 755 756 757
		apply_status=$?
		;;
	t)
		# Resolved means the user did all the hard work, and
		# we do not have to do any patch application.  Just
		# trust what the user has in the index file and the
		# working tree.
		resolved=
758
		git diff-index --quiet --cached HEAD -- && {
759
			echo "No changes - did you forget to use 'git add'?"
760 761
			echo "If there is nothing left to stage, chances are that something else"
			echo "already introduced the same changes; you might want to skip this patch."
762
			stop_here_user_resolve $this
763
		}
764
		unmerged=$(git ls-files -u)
765 766 767
		if test -n "$unmerged"
		then
			echo "You still have unmerged paths in your index"
768
			echo "did you forget to use 'git add'?"
769
			stop_here_user_resolve $this
770
		fi
J
Junio C Hamano 已提交
771
		apply_status=0
772
		git rerere
J
Junio C Hamano 已提交
773 774 775
		;;
	esac

776
	if test $apply_status != 0 && test "$threeway" = t
777
	then
778
		if (fall_back_3way)
779
		then
780 781
		    # Applying the patch to an earlier tree and merging the
		    # result may have produced the same tree as ours.
782
		    git diff-index --quiet --cached HEAD -- && {
S
Stephen Boyd 已提交
783
			say No changes -- Patch already applied.
784 785 786
			go_next
			continue
		    }
787 788
		    # clear apply_status -- we have successfully merged.
		    apply_status=0
789 790 791 792
		fi
	fi
	if test $apply_status != 0
	then
793
		printf 'Patch failed at %s %s\n' "$msgnum" "$FIRSTLINE"
794
		stop_here_user_resolve $this
795 796 797 798 799 800 801
	fi

	if test -x "$GIT_DIR"/hooks/pre-applypatch
	then
		"$GIT_DIR"/hooks/pre-applypatch || stop_here $this
	fi

802
	tree=$(git write-tree) &&
803
	commit=$(
804 805 806 807
		if test -n "$ignore_date"
		then
			GIT_AUTHOR_DATE=
		fi
808
		parent=$(git rev-parse --verify -q HEAD) ||
S
Stephen Boyd 已提交
809
		say >&2 "applying to an empty history"
810

811 812 813 814 815
		if test -n "$committer_date_is_author_date"
		then
			GIT_COMMITTER_DATE="$GIT_AUTHOR_DATE"
			export GIT_COMMITTER_DATE
		fi &&
816
		git commit-tree $tree ${parent:+-p} $parent <"$dotest/final-commit"
817
	) &&
818
	git update-ref -m "$GIT_REFLOG_ACTION: $FIRSTLINE" HEAD $commit $parent ||
819 820
	stop_here $this

T
Thomas Rast 已提交
821 822 823 824
	if test -f "$dotest/original-commit"; then
		echo "$(cat "$dotest/original-commit") $commit" >> "$dotest/rewritten"
	fi

825 826 827 828 829 830 831 832
	if test -x "$GIT_DIR"/hooks/post-applypatch
	then
		"$GIT_DIR"/hooks/post-applypatch
	fi

	go_next
done

833 834 835
if test -s "$dotest"/rewritten; then
    git notes copy --for-rewrite=rebase < "$dotest"/rewritten
    if test -x "$GIT_DIR"/hooks/post-rewrite; then
T
Thomas Rast 已提交
836
	"$GIT_DIR"/hooks/post-rewrite rebase < "$dotest"/rewritten
837
    fi
T
Thomas Rast 已提交
838 839
fi

840
rm -fr "$dotest"
841
git gc --auto